/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxCreate struct for TxCreate
type TxCreate struct {
	// The source UTXO or account ID for the originating funds.
	From string `json:"from"`
	// A list of recipients.
	To       []TxDestination   `json:"to"`
	Contract *TxCreateContract `json:"contract,omitempty"`
	// The UTXO index or the account Nonce. Required for Bitcoin, Bitcoincash, and Litecoin.
	Index *int64 `json:"index,omitempty"`
	// The fee you are willing to pay for the transaction. For Ethereum and Polygon see 'protocol.ethereum' and 'protocol.polygon'.
	Fee      *string           `json:"fee,omitempty"`
	Protocol *TxCreateProtocol `json:"protocol,omitempty"`
}

// NewTxCreate instantiates a new TxCreate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxCreate(from string, to []TxDestination) *TxCreate {
	this := TxCreate{}
	this.From = from
	this.To = to
	return &this
}

// NewTxCreateWithDefaults instantiates a new TxCreate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxCreateWithDefaults() *TxCreate {
	this := TxCreate{}
	return &this
}

// GetFrom returns the From field value
func (o *TxCreate) GetFrom() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.From
}

// GetFromOk returns a tuple with the From field value
// and a boolean to check if the value has been set.
func (o *TxCreate) GetFromOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.From, true
}

// SetFrom sets field value
func (o *TxCreate) SetFrom(v string) {
	o.From = v
}

// GetTo returns the To field value
func (o *TxCreate) GetTo() []TxDestination {
	if o == nil {
		var ret []TxDestination
		return ret
	}

	return o.To
}

// GetToOk returns a tuple with the To field value
// and a boolean to check if the value has been set.
func (o *TxCreate) GetToOk() (*[]TxDestination, bool) {
	if o == nil {
		return nil, false
	}
	return &o.To, true
}

// SetTo sets field value
func (o *TxCreate) SetTo(v []TxDestination) {
	o.To = v
}

// GetContract returns the Contract field value if set, zero value otherwise.
func (o *TxCreate) GetContract() TxCreateContract {
	if o == nil || o.Contract == nil {
		var ret TxCreateContract
		return ret
	}
	return *o.Contract
}

// GetContractOk returns a tuple with the Contract field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreate) GetContractOk() (*TxCreateContract, bool) {
	if o == nil || o.Contract == nil {
		return nil, false
	}
	return o.Contract, true
}

// HasContract returns a boolean if a field has been set.
func (o *TxCreate) HasContract() bool {
	if o != nil && o.Contract != nil {
		return true
	}

	return false
}

// SetContract gets a reference to the given TxCreateContract and assigns it to the Contract field.
func (o *TxCreate) SetContract(v TxCreateContract) {
	o.Contract = &v
}

// GetIndex returns the Index field value if set, zero value otherwise.
func (o *TxCreate) GetIndex() int64 {
	if o == nil || o.Index == nil {
		var ret int64
		return ret
	}
	return *o.Index
}

// GetIndexOk returns a tuple with the Index field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreate) GetIndexOk() (*int64, bool) {
	if o == nil || o.Index == nil {
		return nil, false
	}
	return o.Index, true
}

// HasIndex returns a boolean if a field has been set.
func (o *TxCreate) HasIndex() bool {
	if o != nil && o.Index != nil {
		return true
	}

	return false
}

// SetIndex gets a reference to the given int64 and assigns it to the Index field.
func (o *TxCreate) SetIndex(v int64) {
	o.Index = &v
}

// GetFee returns the Fee field value if set, zero value otherwise.
func (o *TxCreate) GetFee() string {
	if o == nil || o.Fee == nil {
		var ret string
		return ret
	}
	return *o.Fee
}

// GetFeeOk returns a tuple with the Fee field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreate) GetFeeOk() (*string, bool) {
	if o == nil || o.Fee == nil {
		return nil, false
	}
	return o.Fee, true
}

// HasFee returns a boolean if a field has been set.
func (o *TxCreate) HasFee() bool {
	if o != nil && o.Fee != nil {
		return true
	}

	return false
}

// SetFee gets a reference to the given string and assigns it to the Fee field.
func (o *TxCreate) SetFee(v string) {
	o.Fee = &v
}

// GetProtocol returns the Protocol field value if set, zero value otherwise.
func (o *TxCreate) GetProtocol() TxCreateProtocol {
	if o == nil || o.Protocol == nil {
		var ret TxCreateProtocol
		return ret
	}
	return *o.Protocol
}

// GetProtocolOk returns a tuple with the Protocol field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreate) GetProtocolOk() (*TxCreateProtocol, bool) {
	if o == nil || o.Protocol == nil {
		return nil, false
	}
	return o.Protocol, true
}

// HasProtocol returns a boolean if a field has been set.
func (o *TxCreate) HasProtocol() bool {
	if o != nil && o.Protocol != nil {
		return true
	}

	return false
}

// SetProtocol gets a reference to the given TxCreateProtocol and assigns it to the Protocol field.
func (o *TxCreate) SetProtocol(v TxCreateProtocol) {
	o.Protocol = &v
}

func (o TxCreate) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["from"] = o.From
	}
	if true {
		toSerialize["to"] = o.To
	}
	if o.Contract != nil {
		toSerialize["contract"] = o.Contract
	}
	if o.Index != nil {
		toSerialize["index"] = o.Index
	}
	if o.Fee != nil {
		toSerialize["fee"] = o.Fee
	}
	if o.Protocol != nil {
		toSerialize["protocol"] = o.Protocol
	}
	return json.Marshal(toSerialize)
}

type NullableTxCreate struct {
	value *TxCreate
	isSet bool
}

func (v NullableTxCreate) Get() *TxCreate {
	return v.value
}

func (v *NullableTxCreate) Set(val *TxCreate) {
	v.value = val
	v.isSet = true
}

func (v NullableTxCreate) IsSet() bool {
	return v.isSet
}

func (v *NullableTxCreate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxCreate(val *TxCreate) *NullableTxCreate {
	return &NullableTxCreate{value: val, isSet: true}
}

func (v NullableTxCreate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxCreate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
